/*
 * Copyright 2008,2009 Petr Machata
 *
 * This file is part of MicroSweeper.
 *
 * MicroSweeper is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MicroSweeper is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MicroSweeper.  If not, see <http://www.gnu.org/licenses/>.
 */

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

public class MicroSweeper
    extends MIDlet
{
    private final MenuForm menuForm = new MenuForm(this);
    private MineSweeperCanvas activeGame = null;

    public MicroSweeper() {
    	Display.getDisplay(this).setCurrent(menuForm);
    }

    public void startApp() {
    }

    public void pauseApp() {
    }

    public void destroyApp(boolean unconditional) {
    }

    ////
    // Communication with menu...
    ////

    public void exitAction() {
	notifyDestroyed();
    }

    public void continueGame() {
	if (activeGame == null)
	    System.out.println("activeGame should be != null");
	else
	    Display.getDisplay(this).setCurrent(activeGame);
    }

    public void playAction() {
	MineField mf = menuForm.mineField(10, 10,
					  menuForm.wrapX(), menuForm.wrapY(),
					  menuForm.parSel());

	MineFieldBuilder mfb = new RandomMineFieldBuilder
	    (mf, menuForm.howManyMines(), menuForm.acceptor());

	if (activeGame != null) {
	    activeGame.stop();
	    activeGame = null;
	}

	Display.getDisplay(this)
	    .setCurrent(new MineSweeperCanvas(this, mfb));
    }


    ////
    // Communication with game...
    ////

    public void exitGame() {
	activeGame = null;
	menuForm.haveActiveGame(false);
	Display.getDisplay(this).setCurrent(menuForm);
    }

    public void restartGame() {
	playAction();
    }

    public void showMenu(MineSweeperCanvas game) {
	activeGame = game;
	menuForm.haveActiveGame(true);
	Display.getDisplay(this).setCurrent(menuForm);
    }
}
